/*****************
 *
 *  piccel.h
 *
 *  prototypes and support for piccel.c
 *
 ****************/

#include <lcms.h>   // needed for icTagSignature type

extern GdkPixbuf * pLoadBaseImage(char *filename);
extern GdkPixbuf * pLoadProfiledImage(char *filename);

extern char * pLoadInputProfile(char *filename);
extern char * pLoadOutputProfile(char *filename);
extern char * pLoadMonitorProfile(char *filename);

extern char * pProfilesRGB(char code);

extern void pCloseInputProfile();
extern void pCloseOutputProfile();
extern void pCloseMonitorProfile();

extern void pCloseProfiles();

extern void pApplyTransform(GdkPixbuf *inpb, GdkPixbuf *outpb);
extern void pBuildTransform(int ip, int op, int mp, int gamut, int intent, int proofIntent);

extern void prtICCinfo(char pid);
extern char * getICC_ProdName(char pid);
extern char * getICC_ProfInfo(char pid);

extern char * getICCtagText(char pid, icTagSignature tag);

extern BOOL getColorants(char pid, double Rcols[3], double GCols[3], double Bcols[3]);
extern void setColorant(cmsHPROFILE hprofile, icTagSignature tag, double cols[3]);

extern BOOL getMediaPt(char ptId, char pid, double pt[3]);
extern void setMediaPt(cmsHPROFILE hprofile, icTagSignature tag, double pt[3]);

extern icProfileClassSignature getDeviceClass(char pid);
extern icColorSpaceSignature getColSpace(char pid);
extern icColorSpaceSignature getPCS(char pid);
extern DWORD getProfileICCversion(char pid);
extern const LPBYTE getProfileICCid(char pid);
extern int getIntent(char pid);
extern BOOL getCharTargetData(char pid, char **data, size_t *len);
extern LPLUT getLUT(char pid, icTagSignature sig);
extern LPGAMMATABLE getGT(char pid, icTagSignature sig);

extern void lab2xyz(GdkColor *gcolor);
extern void xyz2rgb(GdkColor *gcolor,double gamma);
extern void lab2xyzA(double color[3]);
extern void xyz2rgbA(double color[3],double gamma);
//extern void rgb2xyzA(double color[3]);
extern void rgb2xyzA(double color[3],double gamma);
extern void xyz2labA(double color[3]);

extern cmsHPROFILE chooseProfile (char pid);
extern void set_update_flags(char *wname);
